'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

var _chai = require('chai');

var _ = require('../');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

suite('long-arguments', function () {
	test('boolean flags', function () {
		var _blargs = (0, _2.default)('--one --two --three');

		var _blargs2 = _slicedToArray(_blargs, 1);

		var args = _blargs2[0];

		_chai.assert.isTrue(args.one);
		_chai.assert.isTrue(args.two);
		_chai.assert.isTrue(args.three);
	});
	test('negative boolean flags', function () {
		var _blargs3 = (0, _2.default)('--no-one --no-two --no-three');

		var _blargs4 = _slicedToArray(_blargs3, 1);

		var args = _blargs4[0];

		_chai.assert.isFalse(args.one);
		_chai.assert.isFalse(args.two);
		_chai.assert.isFalse(args.three);
	});
	test('long-name boolean flags', function () {
		var _blargs5 = (0, _2.default)('--one-thing --two-things');

		var _blargs6 = _slicedToArray(_blargs5, 1);

		var args = _blargs6[0];

		_chai.assert.isTrue(args['one-thing']);
		_chai.assert.isTrue(args['two-things']);
	});
	test('long-name negative boolean flags', function () {
		var _blargs7 = (0, _2.default)('--no-one-thing --no-two-things');

		var _blargs8 = _slicedToArray(_blargs7, 1);

		var args = _blargs8[0];

		_chai.assert.isFalse(args['one-thing']);
		_chai.assert.isFalse(args['two-things']);
	});
	test('assignment', function () {
		var _blargs9 = (0, _2.default)('--one=two --two="three four" --three=val,val,val');

		var _blargs10 = _slicedToArray(_blargs9, 1);

		var args = _blargs10[0];

		_chai.assert.equal(args.one, 'two');
		_chai.assert.equal(args.two, 'three four');
		_chai.assert.equal(args.three, 'val,val,val');
	});
	test('complex values', function () {
		var _blargs11 = (0, _2.default)('--one=~`!@#$%^&*()-_+=:;{}[]123|\\/?456<>abcdef,.');

		var _blargs12 = _slicedToArray(_blargs11, 1);

		var args = _blargs12[0];

		_chai.assert.equal(args.one, '~`!@#$%^&*()-_+=:;{}[]123|\\/?456<>abcdef,.');
	});
});

suite('short-arguments', function () {
	test('boolean flags', function () {
		var _blargs13 = (0, _2.default)('-o -n -e');

		var _blargs14 = _slicedToArray(_blargs13, 1);

		var args = _blargs14[0];

		_chai.assert.isTrue(args.o);
		_chai.assert.isTrue(args.n);
		_chai.assert.isTrue(args.e);
	});
	test('multiple boolean flags', function () {
		var _blargs15 = (0, _2.default)('-one');

		var _blargs16 = _slicedToArray(_blargs15, 1);

		var args = _blargs16[0];

		_chai.assert.isTrue(args.o);
		_chai.assert.isTrue(args.n);
		_chai.assert.isTrue(args.e);
	});
	test('negative boolean flags', function () {
		var _blargs17 = (0, _2.default)('-no-o -no-n -no-e');

		var _blargs18 = _slicedToArray(_blargs17, 1);

		var args = _blargs18[0];

		_chai.assert.isFalse(args.o);
		_chai.assert.isFalse(args.n);
		_chai.assert.isFalse(args.e);
	});
	test('multiple negative boolean flags', function () {
		var _blargs19 = (0, _2.default)('-no-one');

		var _blargs20 = _slicedToArray(_blargs19, 1);

		var args = _blargs20[0];

		_chai.assert.isFalse(args.o);
		_chai.assert.isFalse(args.n);
		_chai.assert.isFalse(args.e);
	});
	test('assignment', function () {
		var _blargs21 = (0, _2.default)('-o two -n "three four" -e val,val,val');

		var _blargs22 = _slicedToArray(_blargs21, 1);

		var args = _blargs22[0];

		_chai.assert.equal(args.o, 'two');
		_chai.assert.equal(args.n, 'three four');
		_chai.assert.equal(args.e, 'val,val,val');
	});
	test('complex values', function () {
		var _blargs23 = (0, _2.default)('-o ~`!@#$%^&*()-_+=:;{}[]123|\\/?456<>abcdef,.');

		var _blargs24 = _slicedToArray(_blargs23, 1);

		var args = _blargs24[0];

		_chai.assert.equal(args.o, '~`!@#$%^&*()-_+=:;{}[]123|\\/?456<>abcdef,.');
	});
});

suite('positional arguments', function () {
	test('single positional argument', function () {
		var _blargs25 = (0, _2.default)('argument');

		var _blargs26 = _slicedToArray(_blargs25, 2);

		var args = _blargs26[0];
		var pos = _blargs26[1];

		(0, _chai.assert)(Array.isArray(pos));
		(0, _chai.assert)(pos.length === 1);
		_chai.assert.equal(pos[0], 'argument');
	});
	test('multiple positional arguments', function () {
		var _blargs27 = (0, _2.default)('argument1 argument2 argument3');

		var _blargs28 = _slicedToArray(_blargs27, 2);

		var args = _blargs28[0];
		var pos = _blargs28[1];

		(0, _chai.assert)(Array.isArray(pos));
		(0, _chai.assert)(pos.length === 3);
		_chai.assert.equal(pos[0], 'argument1');
		_chai.assert.equal(pos[1], 'argument2');
		_chai.assert.equal(pos[2], 'argument3');
	});
});

suite('subargs', function () {
	test('spaces, no positionals', function () {
		var _blargs29 = (0, _2.default)('-t [ -n -e --long=short ]');

		var _blargs30 = _slicedToArray(_blargs29, 1);

		var args = _blargs30[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t = _slicedToArray(args.t, 1);

		var targs = _args$t[0];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.equal(targs.long, 'short');
	});
	test('spaces, positionals', function () {
		var _blargs31 = (0, _2.default)('-t [ one -n -e --long=short two ]');

		var _blargs32 = _slicedToArray(_blargs31, 1);

		var args = _blargs32[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t2 = _slicedToArray(args.t, 2);

		var targs = _args$t2[0];
		var tpos = _args$t2[1];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.equal(targs.long, 'short');
		(0, _chai.assert)(Array.isArray(tpos));
		(0, _chai.assert)(tpos.length === 2);
		_chai.assert.equal(tpos[0], 'one');
		_chai.assert.equal(tpos[1], 'two');
	});
	test('no spaces, no positionals', function () {
		var _blargs33 = (0, _2.default)('-t [-n -e --long=short]');

		var _blargs34 = _slicedToArray(_blargs33, 1);

		var args = _blargs34[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t3 = _slicedToArray(args.t, 1);

		var targs = _args$t3[0];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.equal(targs.long, 'short');
	});
	test('no spaces, positionals', function () {
		var _blargs35 = (0, _2.default)('-t [one -n -e --long=short two]');

		var _blargs36 = _slicedToArray(_blargs35, 1);

		var args = _blargs36[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t4 = _slicedToArray(args.t, 2);

		var targs = _args$t4[0];
		var tpos = _args$t4[1];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.equal(targs.long, 'short');
		(0, _chai.assert)(Array.isArray(tpos));
		(0, _chai.assert)(tpos.length === 2);
		_chai.assert.equal(tpos[0], 'one');
		_chai.assert.equal(tpos[1], 'two');
	});
	test('no spaces, end in assignment/value', function () {
		var _blargs37 = (0, _2.default)('-t [-new pos --long=short]');

		var _blargs38 = _slicedToArray(_blargs37, 1);

		var args = _blargs38[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t5 = _slicedToArray(args.t, 2);

		var targs = _args$t5[0];
		var tpos = _args$t5[1];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.isTrue(targs.w);
		(0, _chai.assert)(Array.isArray(tpos));
		(0, _chai.assert)(tpos.length === 1);
		_chai.assert.equal(tpos[0], 'pos');
		_chai.assert.equal(targs.long, 'short');
	});
	test('mixed spaces front, end in assignment/value', function () {
		var _blargs39 = (0, _2.default)('-t [ -new pos --long=short]');

		var _blargs40 = _slicedToArray(_blargs39, 1);

		var args = _blargs40[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t6 = _slicedToArray(args.t, 2);

		var targs = _args$t6[0];
		var tpos = _args$t6[1];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.isTrue(targs.w);
		(0, _chai.assert)(Array.isArray(tpos));
		(0, _chai.assert)(tpos.length === 1);
		_chai.assert.equal(tpos[0], 'pos');
		_chai.assert.equal(targs.long, 'short');
	});
	test('mixed spaces tail, end in assignment/value', function () {
		var _blargs41 = (0, _2.default)('-t [-new pos --long=short ]');

		var _blargs42 = _slicedToArray(_blargs41, 1);

		var args = _blargs42[0];

		(0, _chai.assert)(Array.isArray(args.t));

		var _args$t7 = _slicedToArray(args.t, 2);

		var targs = _args$t7[0];
		var tpos = _args$t7[1];

		_chai.assert.isTrue(targs.n);
		_chai.assert.isTrue(targs.e);
		_chai.assert.isTrue(targs.w);
		(0, _chai.assert)(Array.isArray(tpos));
		(0, _chai.assert)(tpos.length === 1);
		_chai.assert.equal(tpos[0], 'pos');
		_chai.assert.equal(targs.long, 'short');
	});
	test('sub-subargs depth 2', function () {
		var _blargs43 = (0, _2.default)('-z [ -Z [ -z ] ]');

		var _blargs44 = _slicedToArray(_blargs43, 1);

		var args = _blargs44[0];

		(0, _chai.assert)(Array.isArray(args.z));
		(0, _chai.assert)(Array.isArray(args.z[0].Z));
		_chai.assert.isTrue(args.z[0].Z[0].z);
	});
	test('sub-subargs depth 3', function () {
		var _blargs45 = (0, _2.default)('-z [sub1 -Z [sub2 -z [sub3 -Z]]]');

		var _blargs46 = _slicedToArray(_blargs45, 1);

		var args = _blargs46[0];

		(0, _chai.assert)(Array.isArray(args.z));
		(0, _chai.assert)(Array.isArray(args.z[0].Z));
		(0, _chai.assert)(Array.isArray(args.z[0].Z[0].z));
		_chai.assert.isTrue(args.z[0].Z[0].z[0].Z);
		_chai.assert.equal(args.z[1][0], 'sub1');
		_chai.assert.equal(args.z[0].Z[1][0], 'sub2');
		_chai.assert.equal(args.z[0].Z[0].z[1][0], 'sub3');
	});
});

suite('next-command arguments', function () {
	test('next-command depth 1', function () {
		var _blargs47 = (0, _2.default)('arg1 -- arg2 -x');

		var _blargs48 = _slicedToArray(_blargs47, 3);

		var args = _blargs48[0];
		var pos = _blargs48[1];
		var next = _blargs48[2];

		(0, _chai.assert)(Object.keys(args).length === 0);
		_chai.assert.equal(pos[0], 'arg1');
		(0, _chai.assert)(next);

		var _next = _slicedToArray(next, 2);

		args = _next[0];
		pos = _next[1];

		_chai.assert.equal(pos[0], 'arg2');
		_chai.assert.isTrue(args.x);
	});
	test('next-command depth 2', function () {
		var _blargs49 = (0, _2.default)('arg1 -- arg2 -x -- arg3 --end');

		var _blargs50 = _slicedToArray(_blargs49, 3);

		var args = _blargs50[0];
		var pos = _blargs50[1];
		var next = _blargs50[2];

		(0, _chai.assert)(Object.keys(args).length === 0);
		_chai.assert.equal(pos[0], 'arg1');
		(0, _chai.assert)(next);
		var _next2 = next;

		var _next3 = _slicedToArray(_next2, 3);

		args = _next3[0];
		pos = _next3[1];
		next = _next3[2];

		_chai.assert.equal(pos[0], 'arg2');
		_chai.assert.isTrue(args.x);
		(0, _chai.assert)(next);
		var _next4 = next;

		var _next5 = _slicedToArray(_next4, 2);

		args = _next5[0];
		pos = _next5[1];

		_chai.assert.isTrue(args.end);
		_chai.assert.equal(pos[0], 'arg3');
	});
});

suite('error recovery', function () {
	test('short-argument with = assignment', function () {
		var _blargs51 = (0, _2.default)('-Z=two');

		var _blargs52 = _slicedToArray(_blargs51, 1);

		var args = _blargs52[0];

		_chai.assert.equal(args.Z, 'two');
	});
	test('dangling subargs', function () {
		var _blargs53 = (0, _2.default)('-Z [ -z pos');

		var _blargs54 = _slicedToArray(_blargs53, 1);

		var args = _blargs54[0];

		(0, _chai.assert)(Array.isArray(args.Z));
		_chai.assert.equal(args.Z[0].z, 'pos');
	});
	test('dangling double quotes', function () {
		var _blargs55 = (0, _2.default)('-Z "value');

		var _blargs56 = _slicedToArray(_blargs55, 1);

		var args = _blargs56[0];

		_chai.assert.equal(args.Z, 'value');
	});
	test('dangling single quotes', function () {
		var _blargs57 = (0, _2.default)('-Z \'value');

		var _blargs58 = _slicedToArray(_blargs57, 1);

		var args = _blargs58[0];

		_chai.assert.equal(args.Z, 'value');
	});
	test('dangling double quote for quoted positional', function () {
		var _blargs59 = (0, _2.default)('"value""');

		var _blargs60 = _slicedToArray(_blargs59, 2);

		var args = _blargs60[0];
		var pos = _blargs60[1];

		(0, _chai.assert)(pos.length === 1);
		_chai.assert.equal(pos[0], 'value');
	});
	test('dangling single quote for quoted positional', function () {
		var _blargs61 = (0, _2.default)('\'value\'\'');

		var _blargs62 = _slicedToArray(_blargs61, 2);

		var args = _blargs62[0];
		var pos = _blargs62[1];

		(0, _chai.assert)(pos.length === 1);
		_chai.assert.equal(pos[0], 'value');
	});
});

suite('mixed cases', function () {
	test('next-arguments and subargs', function () {
		var _blargs63 = (0, _2.default)('-Z [ sub1 -x ] -- next1 -Z [ sub2 -no-x ]');

		var _blargs64 = _slicedToArray(_blargs63, 3);

		var args = _blargs64[0];
		var next = _blargs64[2];

		_chai.assert.deepEqual(args, {
			Z: [{ x: true }, ['sub1'], null]
		});
		_chai.assert.deepEqual(next, [{
			Z: [{ x: false }, ['sub2'], null]
		}, ['next1'], null]);
	});
	test('next-arguments in subargs', function () {
		var _blargs65 = (0, _2.default)('-Z [-- next -z]');

		var _blargs66 = _slicedToArray(_blargs65, 3);

		var args = _blargs66[0];
		var pos = _blargs66[1];
		var next = _blargs66[2];

		(0, _chai.assert)(args);
		(0, _chai.assert)(args.Z);

		var _args$Z = _slicedToArray(args.Z, 3);

		args = _args$Z[0];
		pos = _args$Z[1];
		next = _args$Z[2];
		var _next6 = next;

		var _next7 = _slicedToArray(_next6, 3);

		args = _next7[0];
		pos = _next7[1];
		next = _next7[2];

		(0, _chai.assert)(pos);
		_chai.assert.equal(pos[0], 'next');
		(0, _chai.assert)(args);
		_chai.assert.isTrue(args.z);
	});
	test('multiples of same arguments', function () {
		var _blargs67 = (0, _2.default)('-z -z -no-z');

		var _blargs68 = _slicedToArray(_blargs67, 1);

		var args = _blargs68[0];

		(0, _chai.assert)(args);
		(0, _chai.assert)(Array.isArray(args.z));
		_chai.assert.deepEqual(args.z, [true, true, false]);
	});
	test('convert false/true string to boolean', function () {
		var _blargs69 = (0, _2.default)('-a true -b false --t1=true --t2=false');

		var _blargs70 = _slicedToArray(_blargs69, 1);

		var args = _blargs70[0];

		_chai.assert.isTrue(args.a);
		_chai.assert.isTrue(args.t1);
		_chai.assert.isFalse(args.b);
		_chai.assert.isFalse(args.t2);
	});
	test('next-arguments in subargs and after (testing recursion)', function () {
		var _blargs71 = (0, _2.default)('--arg=[ arg -- -abc --arg ] -- -abc --arg');

		var _blargs72 = _slicedToArray(_blargs71, 3);

		var args = _blargs72[0];
		var pos = _blargs72[1];
		var next = _blargs72[2];

		_chai.assert.deepEqual(args, {
			arg: [{}, ['arg'], [{ a: true, b: true, c: true, arg: true }, null, null]]
		});
		(0, _chai.assert)(pos === null);
		_chai.assert.deepEqual(next, [{ a: true, b: true, c: true, arg: true }, null, null]);
	});
});